/*
///////////////////////////////////////////////////////////////////////////////////////////////////
//shnQ@kbcvO
//	FileName	demo.c
//	Version		1.00
//	MCU		H8/36057
//	Work		
//-------------------------------------------------------------------------------------------------
//
//	2007/04/05	Ver1.00
//-------------------------------------------------------------------------------------------------
//ldln
//	kbc\vOłB
//	um_Str1vƁum_Str2vŒ`Ă镶݂ɕ\܂B
//-------------------------------------------------------------------------------------------------
*/

/*

̃\tgEFA̓t[EFAłB

̃\tgEFAɊւ鎿ɂ܂ẮA
T|[g̑ΏۊOƂȂ܂B

쌠͍쐬ł()kldqL̂Ƃ܂B

̃\tgEFAgpƂɂSĂ̑QɂāA
쐬͈؂̐ӔC𕉂Ȃ̂Ƃ܂B

̃\tgEFÄꕔ܂͑SĂ𖳒fœ]ڂ邱Ƃ
֎~܂BGȂǂ֏ЉE^̏ꍇ͘A肢v
܂B

@Copyright (C) Hokuto denshi Co,Ltd. 2007

*/

/*
/////////////////////////////////////////////////////////////////////////////////////////
//CN[ht@C錾
*/
#include "36057f.h"
#include <machine.h>


/*
/////////////////////////////////////////////////////////////////////////////////////////
//萔錾
*/
#define VAL_LCD_ROW		16	/* ő */
#define VAL_LCD_COLUMN		2	/* cő */

#define VAL_RS_LOW		0
#define VAL_RS_HIGH		1

/* G[R[h */
#define NOERROR			0

/*
/////////////////////////////////////////////////////////////////////////////////////////
//^錾
*/
typedef struct typeLCD
{
	union 
	{
		struct 
		{
			unsigned char X : 4;
			unsigned char Y : 4;
		} BIT;
		unsigned char BYTE;
	} CURSOR;
} TYPE_STRUCT_LCD;
/*
/////////////////////////////////////////////////////////////////////////////////////////
//ϐ錾
*/
static TYPE_STRUCT_LCD m_LCDInfo;		/* kbc */


/*
//////////////////////////////////////////////////////////////////////////////////////////
//֐vg^Cv錾
*/
extern void reset( void );

void Main( void );
void Wait( const unsigned int msec );
int Port_Init( void );

int Init_LCD ( void );
int Clear_LCD ( void );
int Locate_LCD ( const unsigned char X, const unsigned char Y );
int Print_LCD ( const char *String );
int Write_LCD ( const unsigned char RS_Mode , const unsigned char Data );
void Wait_LCD ( const unsigned long Interval );


/*
//////////////////////////////////////////////////////////////////////////////////////////
//萔錾
*/
const char *m_Str1 = "Tiny I/O 2\nDEMO PROGRAM";
const char *m_Str2 = "LCD DEMO PROGRAM(CPU:H8/36057)";

/*
///////////////////////////////////////////////////////////////////////////////
//reset
//E
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
void reset( void )
{
	set_imask_ccr( 0 );
	_INITSCT();
	Main();
	sleep();
}

/*
///////////////////////////////////////////////////////////////////////////////
//Main
//EC
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
void Main( void )
{
	Port_Init();
	Init_LCD();

	Print_LCD ( m_Str1 );
	
	while(1)
	{
		Wait (1000);
		Clear_LCD ();
		Print_LCD ( m_Str2 );
		Wait (1000);
		Clear_LCD ();
		Print_LCD ( m_Str1 );
	}
}


/*
///////////////////////////////////////////////////////////////////////////////
//Port_Init
//E|[g
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
int Port_Init( void )
{
	*PCR6 = 0xff;		/* Port-6 Output Set */
	*PDR6 = 0x00;		/* Port-6 0x00 Output */
	
	return NOERROR;
}

/*
///////////////////////////////////////////////////////////////////////////////
//Init_LCD
//Ekbc
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
int Init_LCD ( void )
{
	/* ϐ */
	memset ( &m_LCDInfo, 0, sizeof ( TYPE_STRUCT_LCD ) );
	
	*PDR6 = 0x00;
	
	Wait_LCD ( 20 );
	
	*PDR6 = *PDR6 & ~0x04;	/* RS Low Set */

	/* LCD1 */
	*PDR6 = *PDR6 | 0x01;			/* E High Set */
	*PDR6 = ( *PDR6 & 0x0f ) | 0x30;	/*MM1 */
	Wait_LCD ( 1 );
	*PDR6 = *PDR6 & ~0x01;	/* E Low Set */
	Wait_LCD ( 1 );
	
	Wait_LCD ( 5 );
	
	
	/* LCD2 */
	*PDR6 = *PDR6 | 0x01;	/* E High Set */
	*PDR6 = ( *PDR6 & 0x0f ) | 0x30;	/*MM2 */
	Wait_LCD ( 1 );
	*PDR6 = *PDR6 & ~0x01;	/* E Low Set */
	Wait_LCD ( 1 );
	
	
	/* LCD3 */
	*PDR6 = *PDR6 | 0x01;	/* E High Set */
	*PDR6 = ( *PDR6 & 0x0f ) | 0x30;	/*MM3 */
	Wait_LCD ( 1 );
	*PDR6 = *PDR6 & ~0x01;	/* E Low Set */
	Wait_LCD ( 1 );
	
	
	/* LCD4 */
	*PDR6 = *PDR6 | 0x01;	/* E High Set */
	*PDR6 = ( *PDR6 & 0x0f ) | 0x20;	/*MM4 */
	Wait_LCD ( 1 );
	*PDR6 = *PDR6 & ~0x01;	/* E Low Set */
	Wait_LCD ( 1 );
	
	/* t@NVZbgFSrbgoXAQsAT~Vhbg */
	Write_LCD ( VAL_RS_LOW , 0x28 );
	
	/* Gg[[hFJ[\CNgAJ[\ړ */
	Write_LCD ( VAL_RS_LOW , 0x06 );

	/* J[\/\VtgFJ[\EVtg */
	Write_LCD ( VAL_RS_LOW , 0x10 );

	/* \ON/OFFRg[FfBXvC\AJ[\\AuN\ */
	Write_LCD ( VAL_RS_LOW , 0x0d );

	/* \NA */
	Clear_LCD ();
	
	Wait_LCD ( 5 );
	
	return NOERROR;
}


/*
///////////////////////////////////////////////////////////////////////////////
//Clear_LCD
//@kbcF\NA
//-----------------------------------------------------------------------------
//return int
//	NOERROR		: 
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
int Clear_LCD ( void )
{
	*PDR6 = *PDR6 & ~0x04;	/* RS Low Set */
	Write_LCD ( VAL_RS_LOW , 0x01 );
	Wait_LCD ( 2 );
	Locate_LCD ( 0 , 0 );
	return NOERROR;
}


/*
///////////////////////////////////////////////////////////////////////////////
//Locate_LCD
//@kbcFJ[\ړ
//-----------------------------------------------------------------------------
//return int
//	NOERROR		: 
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
int Locate_LCD ( const unsigned char X, const unsigned char Y )
{
	unsigned char i;
	i = Y * 0x40 + X;
	i = i | 0x80;
	
	Write_LCD( VAL_RS_LOW , i );
	Wait_LCD ( 1 );
	
	/* J[\ۑ */
	m_LCDInfo.CURSOR.BIT.X = X;
	m_LCDInfo.CURSOR.BIT.Y = Y;
	
	return NOERROR;
}


/*
///////////////////////////////////////////////////////////////////////////////
//Print_LCD
//@kbcF\
//-----------------------------------------------------------------------------
//return int
//	NOERROR	: 
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
int Print_LCD ( const char *String )
{
	/* ϐ錾 */
	unsigned char i, j;
	
	
	/* \[v */
	for ( i = 0; String[ i ] != '\0'; ++i )
	{
		/* ` */
		if (
			( String[ i ] >= 0x20 && String[ i ] <= 0x7f ) ||
			( String[ i ] >= 0xa1 && String[ i ] <= 0xfd )
		)
		{/* kbcR[h͈͓̔̏ꍇ */
			/* ` */
			Write_LCD ( VAL_RS_HIGH, String[ i ] );
			Wait_LCD ( 1 );
			
			/* J[\ړ */
			if ( m_LCDInfo.CURSOR.BIT.X == VAL_LCD_ROW - 1 )
			{/* 16sI[o[ꍇ */
				m_LCDInfo.CURSOR.BIT.X = 0;
				m_LCDInfo.CURSOR.BIT.Y = ( m_LCDInfo.CURSOR.BIT.Y == 0 ? 1 : 0 );
				Locate_LCD ( m_LCDInfo.CURSOR.BIT.X, m_LCDInfo.CURSOR.BIT.Y );
				for ( j = 0; j < VAL_LCD_ROW; ++j )
					Write_LCD ( VAL_RS_HIGH, ' ' );
				Locate_LCD ( m_LCDInfo.CURSOR.BIT.X, m_LCDInfo.CURSOR.BIT.Y );
			}
			else
			{/* 16sȓ̏ꍇ */
				++m_LCDInfo.CURSOR.BIT.X;
				Locate_LCD ( m_LCDInfo.CURSOR.BIT.X, m_LCDInfo.CURSOR.BIT.Y );
			}/* if ( m_LCDInfo.CURSOR.BIT.X + 1 <= 0x0f ) */
		}
		else if ( String[ i ] == '\n' )
		{/* sR[h̏ꍇ */
			m_LCDInfo.CURSOR.BIT.X = 0;
			m_LCDInfo.CURSOR.BIT.Y = ( m_LCDInfo.CURSOR.BIT.Y == 0 ? 1 : 0 );
			Locate_LCD ( m_LCDInfo.CURSOR.BIT.X, m_LCDInfo.CURSOR.BIT.Y );
			for ( j = 0; j < VAL_LCD_ROW; ++j )
					Write_LCD ( VAL_RS_HIGH, ' ' );
			Locate_LCD ( m_LCDInfo.CURSOR.BIT.X, m_LCDInfo.CURSOR.BIT.Y );
		}
		else
		{/* kbcR[h͈̔͊Ȍꍇ */
			
		}/* if ( ( String[ i ] >= 0x21 && String[ i ] <= 0x7f ) || ( String[ i ] >= 0xa1 && String[ i ] <= 0xfd ) ) */
	}/* while ( String[ i ] != '\0' ) */
	
	
	/* I */
	return NOERROR;
}

/*
///////////////////////////////////////////////////////////////////////////////
//Write_LCD
//@kbcF
//-----------------------------------------------------------------------------
//return int
//	NOERROR		: I
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
int Write_LCD (
	const unsigned char RS_Mode ,
	const unsigned char Data
)
{
	/* 4rbg̏ꍇ */
	/* RS Setting */
	if ( RS_Mode == VAL_RS_LOW )
	{
		*PDR6 = *PDR6 & ~0x04;	/* RS Low Set */
	}
	else if ( RS_Mode == VAL_RS_HIGH )
	{
		*PDR6 = *PDR6 | 0x04 ;	/* RS High Set */
	}
	
	/* 4rbg */
	
	*PDR6 = *PDR6 | 0x01;	/* E High Set */
	
	*PDR6 = ( *PDR6 & 0x0f ) | ( Data & 0xf0 );	/* 4rbg */
	Wait_LCD ( 1 );
	*PDR6 = *PDR6 & ~0x01;	/* E Low Set */
	Wait_LCD ( 1 );
	
	/* 4rbg */
	*PDR6 = *PDR6 | 0x01;	/* E High Set */

	*PDR6 = ( *PDR6 & 0x0f ) | ( ( Data << 4 ) & 0xf0 );
	Wait_LCD ( 1 );
	*PDR6 = *PDR6 & ~0x01;	/* E Low Set */
	Wait_LCD ( 1 );
	
	return NOERROR;
}

/*
///////////////////////////////////////////////////////////////////////////////
//Wait_LCD
//@kbcҋ@
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
void Wait_LCD ( const unsigned long Interval )
{
	volatile unsigned long i;
	for ( i = 0; i < Interval * 1000; ++i );
}

/*
///////////////////////////////////////////////////////////////////////////////
//Wait
//Eԑ҂[v
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
void Wait( const unsigned int msec )
{
	long i;
	for( i=0; i<1000 * ( long )msec; i++ ){
	}
}




#pragma section $DSEC
static const struct {
	void * rom_s;		/* f[^ZNVROM ̐擪AhX */
	void * rom_e;		/* f[^ZNVROM ̍ŏIAhX */
	void * ram_s;		/* f[^ZNVRAM ̐擪AhX */
}DTBL[]={
	{__sectop("D"), __secend ("D"), __sectop ("R")},
	{__sectop("$ABS8D"), __secend ("$ABS8D"), __sectop ("$ABS8R")},
	{__sectop("$ABS16D"), __secend ("$ABS16D"), __sectop ("$ABS16R")}
};
#pragma section $BSEC
static const struct {
	void * b_s;		/* f[^ZNV̐擪AhX */
	void * b_e;		/* f[^ZNV̍ŏIAhX */
}BTBL[]={
	{__sectop("B"), __secend("B")},
	{__sectop("$ABS8B"), __secend("$ABS8B")},
	{__sectop("$ABS16B"), __secend("$ABS16B")}
};
